open Logic
open Prenex

type weight = Int of int | Infty
type indexprinc = string * int
type state = State of (weight * indexprinc list)
type wt = WT of state * (weight * wt) list | Empty

val tree : int -> int -> string list -> wt -> (weight * wt) list 
val gen_tree : int -> int -> string list -> wt 
val processl : ('a * 'b) list -> 'a list
val maximum : weight ref -> weight list -> weight ref 
val max : ('a * 'b) list -> 'a list 
val h_t : weight * wt -> pls -> weight * wt 
val h_s : wt -> pls -> wt 
val trace_value : wt -> weight -> (weight * indexprinc list) list 
val prol : (weight * wt) list -> weight -> (weight * indexprinc list) list
val comparew : weight -> weight -> bool 
val sort_trace : (weight * indexprinc list) list -> (weight * indexprinc list) list 
val sort_ccc : (weight * indexprinc list) list -> (weight * indexprinc list) list 
val max_perm : (weight* indexprinc list) list -> (weight * string list) list 
val rem_per : (weight * string list) list -> (weight * string list) list
val ntree : wt -> pls -> wt
