open Principal
open Context
open Csolver
open Node
open Evalh

let rec extract l = match l with 
(x,y,_,_)::xs-> x::extract xs
|[]->[]

let rec extractp pl =
	match pl with
	  (p,i,v,pr)::zs -> p::extractp zs 
	  |[]-> []

let rec compareList sl nl num =
	match nl with 
	 (w,z)::zs when (sl=z && w=Infty)-> -1
	|(w,z)::zs when sl=z -> num
	|(w,z)::zs-> 0 + compareList sl zs (num+1)
     	|_ -> -2


 let rec rem_ele l e = match l with
  x::xs->if x = e then xs else x::rem_ele xs e
  |[]->[]


let rec sort_ci l = match l with 
    x::xs-> 
	let rec sort_cii ll e =
	 match ll with
   	 y::ys-> if e < y then let tmp = e in sort_cii ys tmp else
    	let tmp = y in sort_cii ys tmp 
    	|[]-> e in 
    	let first = sort_cii xs x in 
	first::sort_ci (rem_ele l first)
|[]->[]

(*let rec reorder ml tl = 
match tl with 
x::xs -> let rec reord lm lt =  
  match lt with 
      y::ys-> let (n,cs) = y in let (c,_,_) = Node.getstatus n in 
      let plist = extractp (Context.getlist c) in 
      compareList plist ml 0
     |[]-> compareList [] ml 0
in let fi= (reord ml x,x) in
fi::reorder ml xs 
|[]-> []*)

let rec reorder ml tl = 
match tl with 
(x,y,z)::xs -> let rec reord lm n =  
      let (c,_,_) = Node.getstatus x in 
      let plist = extractp (Context.getlist c) in 
      compareList (sort_ci plist) ml 0
   in let fi= (reord ml x,(x,y,z)) in
fi::reorder ml xs 
|[]-> []
(*let rec order_list l = 
match l with 
(e,(f,fi)::fis)::ll when e = -1 -> let s = Node.getstatus f in let csi = Csolver.check fi in order_list ll
  |(a,(no,cu)::ns)::ls-> let rec comparel (x,(yo,yoo)::yss) nl = 
    match nl with 
      (c,(di,dii)::dis)::nls->
	let si = Node.getstatus di in let cy=Csolver.check dii in 
	if x>c then  let temp  = (x,(yo,yoo)::yss) in  (comparel temp nls)
	else let  temp=(c,(di,dii)::dis) in (comparel temp nls)
      |[]->(x,(yo,yoo)::yss)
in let (w,z)=(comparel (a,(no,cu)::ns) ls) in 
z::(order_list (rem_ele l (w,z))) (*(List.filter (fun (u,v)-> if (w=u && z=v) then false else true) l))*)
  |[]->[]*)
let rec order_list l = match l with 
      (a,b)::ll when a= -1 -> order_list ll
      |(a,b)::ls -> let rec comparel (x,y) nl tl =
      match nl with    
      (c,d)::nls -> if x > c then let temp =(x,y) in let 
      templ = (c,d)::tl in
      comparel temp nls templ 
      else  let temp=(c,d) in let templ = (x,y)::tl in comparel temp nls templ 
    |[]->(x,y)::tl in
    let (w,z)::zs = comparel (a,b) ls [] in
    z::order_list zs
  |[]->[]



