(* Tokenizer interface *)
type ltok = LIde of string
	| LSym of string
	| LEnd
	| LStop
	| LUnknown of char;;

type lbuf
val getToken: unit->ltok
val pushback: ltok -> unit
val init_tokenizer: string -> unit
val done_tokenizer: unit -> unit
val flushline: unit -> unit
val where: unit -> (int*int)
