(*
	Action.mli
	30/01/2003
	Giacomo Baldi

	Definition of actions.
*)

open Message
open Assignment

type action =
	| Input of pname*msg*assignment
	| Output of pname*msg*assignment
	| Join of pname*assignment
	| NoMoreAct
	| Closed

val equal: action -> action -> bool
val prnt: action -> unit
val tostring: action -> string
