(*
	Thestack.ml
	23/08/03
	Giacomo Baldi

	Implementation of a stack
*)

open Utils

exception StackException
type 'a stack = 'a list


let init = 
	function bottom -> [bottom]

let push = 
	function ns -> 
	function n ->
		n::ns
		
let pushl =
	function ns ->
	function nl -> nl@ns

let pushlr =
	function ns ->
	function nl -> reverse(nl)@ns

let pop =
	function ns ->
		if ns=[] then raise StackException
		else tail ns
let top =
	function ns ->
		if ns=[] then raise StackException
		else head ns

let isEmpty =
	function ns ->
		ns = []

let length =
  function ns ->  len ns;
