(*
	Thestack.mli
	23/08/03
	Giacomo Baldi

	Definition of a stack of nodes to implement search
*)

exception StackException

type 'a stack

val init: 'a -> 'a stack
val push: 'a stack -> 'a ->  'a stack
val pushl: 'a stack -> 'a list -> 'a stack
val pushlr: 'a stack -> 'a list -> 'a stack
val pop: 'a stack -> 'a stack
val top: 'a stack -> 'a 
val isEmpty: 'a stack -> bool
val length: 'a stack -> int
