(*
	Join.mli
	26/05/2003
	Giacomo Baldi

	Definition of join functions
*)
open Node
open Message
open Assignment
open Kmanager
open Princpool

val initjoin: ppool -> km -> int list -> node -> node

val joinwithmodel: km -> bool -> node -> (assignment*'a) list -> (node*'a) list

val joincontext: km -> bool -> node -> node list

val getinitialnodes: int -> int -> int
